﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Runtime.InteropServices;

namespace scroller
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Bitmap BM = new Bitmap(pictureBox1.ClientSize.Width, pictureBox1.ClientSize.Height);
            pictureBox1.BackgroundImage = BM;
            for (int x = 0; x < 10000; x++)
            {
                int y = (int)(Math.Sin((double)x / 50) * BM.Height / 2 + BM.Height / 2);
                BM.SetPixel(0, y, Color.Black);
                BM = BM.Scroll(1, 0);
                pictureBox1.BackgroundImage = BM;
                Application.DoEvents();

            }

        }

        private void button2_Click(object sender, EventArgs e)
        {
            Graphics G = pictureBox1.CreateGraphics();
            for (int x = 0; x < 10000; x++)
            {
                int y = (int)(Math.Sin((double)x / 50) * pictureBox1.ClientSize.Height / 2 + pictureBox1.ClientSize.Height / 2);
                G.DrawLine(Pens.Blue, 1, y, 1, y + 1);
                pictureBox1.Scroll(1, 0);
                Application.DoEvents();

            }
            G.Dispose();
         }
    }
    public static class MyExtensions
    {

        [DllImport("user32.dll")]
        private static extern int ScrollWindowEx(
            System.IntPtr hWnd,
            int dx,
            int dy,
            [MarshalAs(UnmanagedType.LPStruct)] 
            RECT prcScroll,
            [MarshalAs(UnmanagedType.LPStruct)] 
            RECT prcClip,
            System.IntPtr hrgnUpdate,
            [MarshalAs(UnmanagedType.LPStruct)] 
            RECT prcUpdate,
            System.UInt32 flags
            );
        [StructLayout(LayoutKind.Sequential)]
        public class RECT
        {
            public Int32 left;
            public Int32 top;
            public Int32 right;
            public Int32 bottom;
        }


        public static Bitmap Scroll(this Bitmap BM, int dx, int dy)
        {
            Bitmap BMTemp = new Bitmap(BM.Width, BM.Height);
            Graphics G = Graphics.FromImage(BMTemp);
            G.DrawImage(BM, dx, dy);
            G.Dispose();
            return BMTemp;
        }
        public static void Scroll(this PictureBox BP, int dx, int dy)
        {
            ScrollWindowEx(BP.Handle, dx, dy, null, null, IntPtr.Zero, null, 2);

        }
    }

}


